#if !defined(tred1_run)
 #define kgrafik_run

#include<graphics.h>
#include<math.h>
#include<conio.h>
#include<alloc.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<process.h>

#define byte unsigned char

extern byte background[4096];

struct sheader
       {unsigned short int base;
	unsigned short int unk1, unk2, unk3;
	unsigned short int ochecksum;
	unsigned short int unk4;
	unsigned short int otrackdata;
       };

extern struct sheader header;

extern byte *objects,endheader[256];

struct strackheader
       {short int startangle, startheight;
	short int startY, startZ, startX;
	short int startWidth, poleWidth;
	byte pitside, trsurround, rbank, lbank;
	short int kerbcnum,unk1;
	short int kerbtopcolor, kerbbottomcolor, unk2;
	short int kerbtopcolor2, kerbbottomcolor2;
       };

extern struct strackheader trackheader;

struct sCCsetup
       {byte fwing,rwing;
	byte g1,g2,g3,g4,g5,g6;
	byte tyretype,brakeb;
	short int grip,QA,RA,QT;
	short int accel,airres,unk1,TW1,TW2,RT;
	short int unk2,wetRA,unk3,unk4;
       };
extern struct sCCsetup CCsetup;

struct command
       {unsigned char cmd;
	unsigned char a0;
	short int a1,a2,a3,a4,a5;
	struct command *elo,*kov;
       };

extern struct command *trcmd,*picmd;

struct trackseg
       {
	unsigned short int tlu;
	short int curvature;
	short int height;
	unsigned short int flags;
	byte rbank;
	byte lbank;
	short int sign;
	double length;
	double cumlength;
	long int cumgrad,cumheight;
	double fik,fiv;
	double r;
	double kx,ky, vx,vy;
	byte middle;
	double fim;
	double mx,my;
	double ox,oy;
	double ks[2],vs[2];
	struct command *cmd;
	struct trackseg *elo,*kov;
       };

extern struct trackseg *ktrack,*kpit, *atrack,*apit;

struct bestlineseg
       {byte tlu;
	byte type;
	short int a1,a2,a3;
	long int bigrad;
	short int sign;
	double length;
	double s;
	double fik,fiv;
	double r;
	double ox,oy;
	double kx,ky,vx,vy;
	struct bestlineseg *elo,*kov, *pre;
       };

extern struct bestlineseg *kbl,*ablseg;


extern double scale, anglescale, radscale, carwidth, widthscale, pitwidth;
extern int maxx,maxy, maxtx,maxty, dx,dy;
extern short int drawpoints;/*if !=0, draw centre point and radius of every best line segment*/
extern short int drawsegs;/*if!=0, draw lines in the track segment at the end of every tlu*/
extern short int lapnumindex;/* endheader[lapnumindex]=number of laps */


/*signum function*/
short int sgn(double x);

/*round*/
int f2i(double f);

/**********************************/
/*draw an arc with variable radius*/
/**********************************/
void arc2(int x,int y,float stangle,float endangle,float str,float endr);

/*************/
/*draw a line*/
/*************/
void line2(int kx, int ky, int vx,int vy);

/*************************/
/*write a string to (x,y)*/
/*************************/
void writexy(int x,int y,char *str);

/**********************************************/
/*allocate memory for a new trackseg structure*/
/**********************************************/
struct trackseg *newtrackseg();

/*************************************************/
/*allocate memory for a new bestlineseg structure*/
/*************************************************/
struct bestlineseg *newbestlineseg();

/*************************************************/
/*allocate memory for a new command structure*/
/*************************************************/
struct command *newcommand();

/********************/
/*draw track segment*/
/********************/
void drawtracksegment(struct trackseg *ftr);

/**********************/
/*draw CC line segment*/
/**********************/
void drawCClinesegment(struct bestlineseg *fbl);

/***********************/
/*refresh the track map*/
/***********************/
void refreshmap();

/************************************/
/*refresh track and pitlane segments*/
/************************************/
void refreshtrack();

/**************************/
/*refresh CC line segments*/
/**************************/
void refreshCCline();

/********************************/
/*draw track and best line datas*/
/********************************/
void drawgraph();

/**********************/
/*load track file data*/
/**********************/
void loadtrack(char *filename);

/**********************/
/*save track file data*/
/**********************/
void savetrack(char *filename);


#endif